# Copyright (C) 1991--2010 by INRIA.
#
# This file is part of Algolib.
#
# Algolib is free software: you can redistribute it and/or modify it
# under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# Algolib is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with Algolib.  If not, see
# <http://www.gnu.org/licenses/>.

`multiseries/function`[`erfc/infinity/aux/0/-1/2*Pi .. 1/2*Pi`, 0]:=proc (expr, scale, var, order) local loc1, loc2, res, res1; option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 10/26/2004 @ 23:25:01`; ASSERT(`multiseries/limit`(expr,scale,var) = 0 or Testzero(`multiseries/limit`(expr,scale,var))); loc1 := MultiSeries:-`multiseries/function`[`erfc/infinity/aux/0/-1/2*Pi .. 1/2*Pi`,0,"BasisVector",0,"MultiSeries"](expr,scale,var,order); loc2 := 1/Pi^(1/2); if nops(loc1) = 1 then loc1 := [subsop(9 = 1/loc2*`erfc/infinity/aux/0/-1/2*Pi .. 1/2*Pi`(eval(scale['variable'],1)),op(1,loc1))] end if; res1 := MultiSeries:-`multiseries/function`["Helper","RegularBasisVector"](loc1,[expr, scale, var, order],0,loc2,0); res := res1; subsop(9 = `erfc/infinity/aux/0/-1/2*Pi .. 1/2*Pi`(op(9,expr)),res) end proc:
`multiseries/function`[`erfc/infinity/aux/1/-Pi .. -1/2*Pi`, 0]:=proc (expr, scale, var, order) local loc1, loc2, res, res1; option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 10/26/2004 @ 23:25:04`; ASSERT(`multiseries/limit`(expr,scale,var) = 0 or Testzero(`multiseries/limit`(expr,scale,var))); loc1 := MultiSeries:-`multiseries/function`[`erfc/infinity/aux/1/-Pi .. -1/2*Pi`,0,"BasisVector",0,"MultiSeries"](expr,scale,var,order); loc2 := 1/Pi^(1/2); if nops(loc1) = 1 then loc1 := [subsop(9 = 1/loc2*`erfc/infinity/aux/1/-Pi .. -1/2*Pi`(eval(scale['variable'],1)),op(1,loc1))] end if; res1 := MultiSeries:-`multiseries/function`["Helper","RegularBasisVector"](loc1,[expr, scale, var, order],0,loc2,0); res := res1; subsop(9 = `erfc/infinity/aux/1/-Pi .. -1/2*Pi`(op(9,expr)),res) end proc:
`multiseries/function`[erfc]:=proc (expr, scale, var, order) local lim, lim2, asymptdir, argseq, res; option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 10/26/2004 @ 23:25:08`; if expr = 0 then return `multiseries/Convert2SERIES`(erfc(0),scale,var,false) end if; lim := `multiseries/limit`(expr,scale,var); lim2 := lim; if lim = undefined then error "unable to compute series" elif has(lim,infinity) then if has(lim,exp) then asymptdir := op(select(type,lim,specfunc(anything,exp))) elif 1 < nops(lim) then asymptdir := argument(subs(infinity = 1,lim)) else asymptdir := 0 end if; lim := infinity else asymptdir := argument(lim) end if; if lim = infinity then argseq := `multiseries/pow`(expr,-1,scale,var,order), scale, var, order else argseq := `multiseries/AddDoit`(expr,`multiseries/Convert2SERIES`(-lim,scale,var,false)), scale, var, order end if; if lim = 0 then res := `multiseries/function`[erfc,0](argseq) elif lim = infinity then if evalb(signum(-1/2*Pi-asymptdir) <> 1) and evalb(signum(1/2*Pi-asymptdir) <> -1) then res := `multiseries/function`[erfc,infinity,-1/2*Pi .. 1/2*Pi](argseq,[op(1,[argseq]), scale, var, order]) elif evalb(signum(1/2*Pi-asymptdir) <> 1) and evalb(signum(Pi-asymptdir) <> -1) then res := `multiseries/function`[erfc,infinity,1/2*Pi .. Pi](argseq,[op(1,[argseq]), scale, var, order]) elif evalb(signum(-Pi-asymptdir) <> 1) and evalb(signum(-1/2*Pi-asymptdir) <> -1) then res := `multiseries/function`[erfc,infinity,-Pi .. -1/2*Pi](argseq,[op(1,[argseq]), scale, var, order]) end if else res := eval(`multiseries/function`[erfc,_AnyFiniteOrdinaryPoint](argseq),_AnyFiniteOrdinaryPoint = lim) end if; subsop(9 = erfc(op(9,expr)),res) end proc:
`multiseries/function`[erfc, _AnyFiniteOrdinaryPoint]:=proc (expr, scale, var, order) option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 10/26/2004 @ 23:24:58`; `multiseries/compose`(SERIES(scale,map(normal,MultiSeries:-`multiseries/function`[erf,_AnyFiniteOrdinaryPoint,"CoeffProc"](order,erfc(_AnyFiniteOrdinaryPoint),-2/Pi^(1/2)*exp(-_AnyFiniteOrdinaryPoint^2),_AnyFiniteOrdinaryPoint)),1,algebraic,[`$`(0 .. order)],order+1,integer,eval(scale['variable'],1),erfc(_AnyFiniteOrdinaryPoint+eval(scale['variable'],1))),expr,scale,var,order) end proc:
`multiseries/function`[erfc, infinity, -Pi .. -1/2*Pi]:=proc (expr, scale, var, order, arglist) local res; option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 10/26/2004 @ 23:25:05`; res := `multiseries/add`([`multiseries/Convert2SERIES`(2,scale,var,false), `multiseries/mul`([expr, MultiSeries:-`multiseries/function`[exp](`multiseries/MulDoit`(`multiseries/pow`(expr,-2,scale,var,order),-1),scale,var,order), MultiSeries:-`multiseries/function`[`erfc/infinity/aux/1/-Pi .. -1/2*Pi`](op(arglist))])]) end proc:
`multiseries/function`[erfc, infinity, 1/2*Pi .. Pi]:=proc (expr, scale, var, order, arglist) local res; option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 10/26/2004 @ 23:25:08`; res := `multiseries/add`([`multiseries/Convert2SERIES`(2,scale,var,false), `multiseries/mul`([expr, MultiSeries:-`multiseries/function`[exp](`multiseries/MulDoit`(`multiseries/pow`(expr,-2,scale,var,order),-1),scale,var,order), MultiSeries:-`multiseries/function`[`erfc/infinity/aux/1/1/2*Pi .. Pi`](op(arglist))])]) end proc:
`multiseries/function`[`erfc/infinity/aux/0/-1/2*Pi .. 1/2*Pi`, 0, "BasisVector", 0, "MultiSeries"]:=proc (expr, scale, var, order) option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 10/26/2004 @ 23:25:01`; [MultiSeries:-`multiseries/function`[`erfc/infinity/aux/0/-1/2*Pi .. 1/2*Pi`,0,"BasisVector",0,"MultiSeries",0](args)] end proc:
`multiseries/function`[`erfc/infinity/aux/1/1/2*Pi .. Pi`, 0, "CoeffProc"]:=proc (n, c) local i1, loc; option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 10/26/2004 @ 23:25:06`; if n = 0 then [1] elif n = 1 then [1, 0] else loc[0] := 1; loc[1] := 0; for i1 from 2 to n do loc[i1] := -1/2*(c-1+i1)*loc[i1-2] end do; [seq(loc[i1],i1 = 0 .. n)] end if end proc:
`multiseries/function`[`erfc/infinity/aux/1/1/2*Pi .. Pi`, 0, "CoeffProc", 0]:=proc (n) option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 10/26/2004 @ 23:25:07`; MultiSeries:-`multiseries/function`[`erfc/infinity/aux/1/1/2*Pi .. Pi`,0,"CoeffProc"](n,0) end proc:
`multiseries/function`[`erfc/infinity/aux/1/1/2*Pi .. Pi`, 0, "BasisVector", 0, "MultiSeries"]:=proc (expr, scale, var, order) option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 10/26/2004 @ 23:25:07`; [MultiSeries:-`multiseries/function`[`erfc/infinity/aux/1/1/2*Pi .. Pi`,0,"BasisVector",0,"MultiSeries",0](args)] end proc:
`multiseries/function`[`erfc/infinity/aux/0/-1/2*Pi .. 1/2*Pi`, 0, "BasisVector", 0, "MultiSeries", 0]:=proc (expr, scale, var, order) option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 10/26/2004 @ 23:25:00`; SERIES(scale,MultiSeries:-`multiseries/function`[`erfc/infinity/aux/0/-1/2*Pi .. 1/2*Pi`,0,"CoeffProc",0](order),1,algebraic,[`$`(0 .. order)],order+1,integer,eval(scale['variable'],1),`erfc/infinity/aux/0/-1/2*Pi .. 1/2*Pi/0/BasisVector/0/MultiSeries/0`(eval(scale['variable'],1))) end proc:
`multiseries/function`[`erfc/infinity/aux/0/-1/2*Pi .. 1/2*Pi`]:=proc (expr, scale, var, order) local lim, lim2, argseq, res; option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 10/26/2004 @ 23:25:01`; if expr = 0 then return `multiseries/Convert2SERIES`(`erfc/infinity/aux/0/-1/2*Pi .. 1/2*Pi`(0),scale,var,false) end if; lim := `multiseries/limit`(expr,scale,var); if lim = infinity then argseq := `multiseries/pow`(expr,-1,scale,var,order), scale, var, order else argseq := `multiseries/AddDoit`(expr,`multiseries/Convert2SERIES`(-lim,scale,var,false)), scale, var, order end if; if lim = 0 then res := MultiSeries:-`multiseries/function`[`erfc/infinity/aux/0/-1/2*Pi .. 1/2*Pi`,0](argseq) elif member(lim,{infinity}) then error "unable to compute series" else res := eval(MultiSeries:-`multiseries/function`[`erfc/infinity/aux/0/-1/2*Pi .. 1/2*Pi`,_AnyFiniteOrdinaryPoint](argseq),_AnyFiniteOrdinaryPoint = lim) end if; subsop(9 = `erfc/infinity/aux/0/-1/2*Pi .. 1/2*Pi`(op(9,expr)),res) end proc:
`multiseries/function`[`erfc/infinity/aux/0/-1/2*Pi .. 1/2*Pi`, 0, "BasisVector", 0]:=proc (n) option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 10/26/2004 @ 23:25:00`; [0, MultiSeries:-`multiseries/function`[`erfc/infinity/aux/0/-1/2*Pi .. 1/2*Pi`,0,"CoeffProc"](n,0)] end proc:
`multiseries/function`[`erfc/infinity/aux/1/-Pi .. -1/2*Pi`, 0, "CoeffProc", 0]:=proc (n) option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 10/26/2004 @ 23:25:03`; MultiSeries:-`multiseries/function`[`erfc/infinity/aux/1/-Pi .. -1/2*Pi`,0,"CoeffProc"](n,0) end proc:
`multiseries/function`[`erfc/infinity/aux/0/-1/2*Pi .. 1/2*Pi`, 0, "CoeffProc", 0]:=proc (n) option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 10/26/2004 @ 23:25:00`; MultiSeries:-`multiseries/function`[`erfc/infinity/aux/0/-1/2*Pi .. 1/2*Pi`,0,"CoeffProc"](n,0) end proc:
`multiseries/function`[`erfc/infinity/aux/1/1/2*Pi .. Pi`, 0, "BasisVector", 0, "MultiSeries", 0]:=proc (expr, scale, var, order) option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 10/26/2004 @ 23:25:07`; SERIES(scale,MultiSeries:-`multiseries/function`[`erfc/infinity/aux/1/1/2*Pi .. Pi`,0,"CoeffProc",0](order),1,algebraic,[`$`(0 .. order)],order+1,integer,eval(scale['variable'],1),`erfc/infinity/aux/1/1/2*Pi .. Pi/0/BasisVector/0/MultiSeries/0`(eval(scale['variable'],1))) end proc:
`multiseries/function`[`erfc/infinity/aux/1/-Pi .. -1/2*Pi`, 0, "BasisVector", 0, "MultiSeries", 0]:=proc (expr, scale, var, order) option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 10/26/2004 @ 23:25:04`; SERIES(scale,MultiSeries:-`multiseries/function`[`erfc/infinity/aux/1/-Pi .. -1/2*Pi`,0,"CoeffProc",0](order),1,algebraic,[`$`(0 .. order)],order+1,integer,eval(scale['variable'],1),`erfc/infinity/aux/1/-Pi .. -1/2*Pi/0/BasisVector/0/MultiSeries/0`(eval(scale['variable'],1))) end proc:
`multiseries/function`[erfc, infinity, -1/2*Pi .. 1/2*Pi]:=proc (expr, scale, var, order, arglist) local res; option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 10/26/2004 @ 23:25:02`; res := `multiseries/add`([`multiseries/mul`([expr, MultiSeries:-`multiseries/function`[exp](`multiseries/MulDoit`(`multiseries/pow`(expr,-2,scale,var,order),-1),scale,var,order), MultiSeries:-`multiseries/function`[`erfc/infinity/aux/0/-1/2*Pi .. 1/2*Pi`](op(arglist))])]) end proc:
`multiseries/function`[`erfc/infinity/aux/1/-Pi .. -1/2*Pi`, _AnyFiniteOrdinaryPoint]:=proc (expr, scale, var, order) option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 10/26/2004 @ 23:25:02`; `multiseries/compose`(SERIES(scale,map(normal,MultiSeries:-`multiseries/function`[`erf/infinity/aux/1/-1/2*Pi .. 1/2*Pi`,_AnyFiniteOrdinaryPoint,"CoeffProc"](order,`erfc/infinity/aux/1/-Pi .. -1/2*Pi`(_AnyFiniteOrdinaryPoint),diff(`erfc/infinity/aux/1/-Pi .. -1/2*Pi`(_AnyFiniteOrdinaryPoint),_AnyFiniteOrdinaryPoint),_AnyFiniteOrdinaryPoint)),1,algebraic,[`$`(0 .. order)],order+1,integer,eval(scale['variable'],1),`erfc/infinity/aux/1/-Pi .. -1/2*Pi`(_AnyFiniteOrdinaryPoint+eval(scale['variable'],1))),expr,scale,var,order) end proc:
`multiseries/function`[erfc, 0]:=proc (expr, scale, var, order) option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 10/26/2004 @ 23:24:58`; `multiseries/compose`(SERIES(scale,MultiSeries:-`multiseries/function`[erf,_AnyFiniteOrdinaryPoint,"CoeffProc"](order,1,-2/Pi^(1/2),0),1,algebraic,[`$`(0 .. order)],order+1,integer,eval(scale['variable'],1),erfc(eval(scale['variable'],1))),expr,scale,var,order) end proc:
`multiseries/function`[`erfc/infinity/aux/1/1/2*Pi .. Pi`, 0]:=proc (expr, scale, var, order) local loc1, loc2, res, res1; option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 10/26/2004 @ 23:25:08`; ASSERT(`multiseries/limit`(expr,scale,var) = 0 or Testzero(`multiseries/limit`(expr,scale,var))); loc1 := MultiSeries:-`multiseries/function`[`erfc/infinity/aux/1/1/2*Pi .. Pi`,0,"BasisVector",0,"MultiSeries"](expr,scale,var,order); loc2 := 1/Pi^(1/2); if nops(loc1) = 1 then loc1 := [subsop(9 = 1/loc2*`erfc/infinity/aux/1/1/2*Pi .. Pi`(eval(scale['variable'],1)),op(1,loc1))] end if; res1 := MultiSeries:-`multiseries/function`["Helper","RegularBasisVector"](loc1,[expr, scale, var, order],0,loc2,0); res := res1; subsop(9 = `erfc/infinity/aux/1/1/2*Pi .. Pi`(op(9,expr)),res) end proc:
`multiseries/function`[`erfc/infinity/aux/1/-Pi .. -1/2*Pi`, 0, "CoeffProc"]:=proc (n, c) local i1, loc; option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 10/26/2004 @ 23:25:02`; if n = 0 then [1] elif n = 1 then [1, 0] else loc[0] := 1; loc[1] := 0; for i1 from 2 to n do loc[i1] := -1/2*(c-1+i1)*loc[i1-2] end do; [seq(loc[i1],i1 = 0 .. n)] end if end proc:
`multiseries/function`[`erfc/infinity/aux/1/1/2*Pi .. Pi`]:=proc (expr, scale, var, order) local lim, lim2, argseq, res; option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 10/26/2004 @ 23:25:08`; if expr = 0 then return `multiseries/Convert2SERIES`(`erfc/infinity/aux/1/1/2*Pi .. Pi`(0),scale,var,false) end if; lim := `multiseries/limit`(expr,scale,var); if lim = infinity then argseq := `multiseries/pow`(expr,-1,scale,var,order), scale, var, order else argseq := `multiseries/AddDoit`(expr,`multiseries/Convert2SERIES`(-lim,scale,var,false)), scale, var, order end if; if lim = 0 then res := MultiSeries:-`multiseries/function`[`erfc/infinity/aux/1/1/2*Pi .. Pi`,0](argseq) elif member(lim,{infinity}) then error "unable to compute series" else res := eval(MultiSeries:-`multiseries/function`[`erfc/infinity/aux/1/1/2*Pi .. Pi`,_AnyFiniteOrdinaryPoint](argseq),_AnyFiniteOrdinaryPoint = lim) end if; subsop(9 = `erfc/infinity/aux/1/1/2*Pi .. Pi`(op(9,expr)),res) end proc:
`multiseries/function`[`erfc/infinity/aux/1/-Pi .. -1/2*Pi`, 0, "BasisVector", 0]:=proc (n) option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 10/26/2004 @ 23:25:03`; [0, MultiSeries:-`multiseries/function`[`erfc/infinity/aux/1/-Pi .. -1/2*Pi`,0,"CoeffProc"](n,0)] end proc:
`multiseries/function`[`erfc/infinity/aux/1/-Pi .. -1/2*Pi`, 0, "BasisVector", 0, "MultiSeries"]:=proc (expr, scale, var, order) option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 10/26/2004 @ 23:25:04`; [MultiSeries:-`multiseries/function`[`erfc/infinity/aux/1/-Pi .. -1/2*Pi`,0,"BasisVector",0,"MultiSeries",0](args)] end proc:
`multiseries/function`[`erfc/infinity/aux/1/1/2*Pi .. Pi`, _AnyFiniteOrdinaryPoint]:=proc (expr, scale, var, order) option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 10/26/2004 @ 23:25:05`; `multiseries/compose`(SERIES(scale,map(normal,MultiSeries:-`multiseries/function`[`erf/infinity/aux/1/-1/2*Pi .. 1/2*Pi`,_AnyFiniteOrdinaryPoint,"CoeffProc"](order,`erfc/infinity/aux/1/1/2*Pi .. Pi`(_AnyFiniteOrdinaryPoint),diff(`erfc/infinity/aux/1/1/2*Pi .. Pi`(_AnyFiniteOrdinaryPoint),_AnyFiniteOrdinaryPoint),_AnyFiniteOrdinaryPoint)),1,algebraic,[`$`(0 .. order)],order+1,integer,eval(scale['variable'],1),`erfc/infinity/aux/1/1/2*Pi .. Pi`(_AnyFiniteOrdinaryPoint+eval(scale['variable'],1))),expr,scale,var,order) end proc:
`multiseries/function`[`erfc/infinity/aux/1/1/2*Pi .. Pi`, 0, "BasisVector", 0]:=proc (n) option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 10/26/2004 @ 23:25:06`; [0, MultiSeries:-`multiseries/function`[`erfc/infinity/aux/1/1/2*Pi .. Pi`,0,"CoeffProc"](n,0)] end proc:
`multiseries/function`[`erfc/infinity/aux/1/-Pi .. -1/2*Pi`]:=proc (expr, scale, var, order) local lim, lim2, argseq, res; option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 10/26/2004 @ 23:25:05`; if expr = 0 then return `multiseries/Convert2SERIES`(`erfc/infinity/aux/1/-Pi .. -1/2*Pi`(0),scale,var,false) end if; lim := `multiseries/limit`(expr,scale,var); if lim = infinity then argseq := `multiseries/pow`(expr,-1,scale,var,order), scale, var, order else argseq := `multiseries/AddDoit`(expr,`multiseries/Convert2SERIES`(-lim,scale,var,false)), scale, var, order end if; if lim = 0 then res := MultiSeries:-`multiseries/function`[`erfc/infinity/aux/1/-Pi .. -1/2*Pi`,0](argseq) elif member(lim,{infinity}) then error "unable to compute series" else res := eval(MultiSeries:-`multiseries/function`[`erfc/infinity/aux/1/-Pi .. -1/2*Pi`,_AnyFiniteOrdinaryPoint](argseq),_AnyFiniteOrdinaryPoint = lim) end if; subsop(9 = `erfc/infinity/aux/1/-Pi .. -1/2*Pi`(op(9,expr)),res) end proc:
`multiseries/function`[`erfc/infinity/aux/0/-1/2*Pi .. 1/2*Pi`, _AnyFiniteOrdinaryPoint]:=proc (expr, scale, var, order) option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 10/26/2004 @ 23:24:59`; `multiseries/compose`(SERIES(scale,map(normal,MultiSeries:-`multiseries/function`[`erf/infinity/aux/1/-1/2*Pi .. 1/2*Pi`,_AnyFiniteOrdinaryPoint,"CoeffProc"](order,`erfc/infinity/aux/0/-1/2*Pi .. 1/2*Pi`(_AnyFiniteOrdinaryPoint),diff(`erfc/infinity/aux/0/-1/2*Pi .. 1/2*Pi`(_AnyFiniteOrdinaryPoint),_AnyFiniteOrdinaryPoint),_AnyFiniteOrdinaryPoint)),1,algebraic,[`$`(0 .. order)],order+1,integer,eval(scale['variable'],1),`erfc/infinity/aux/0/-1/2*Pi .. 1/2*Pi`(_AnyFiniteOrdinaryPoint+eval(scale['variable'],1))),expr,scale,var,order) end proc:
`multiseries/function`[`erfc/infinity/aux/0/-1/2*Pi .. 1/2*Pi`, 0, "CoeffProc"]:=proc (n, c) local i1, loc; option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 10/26/2004 @ 23:24:59`; if n = 0 then [1] elif n = 1 then [1, 0] else loc[0] := 1; loc[1] := 0; for i1 from 2 to n do loc[i1] := -1/2*(c-1+i1)*loc[i1-2] end do; [seq(loc[i1],i1 = 0 .. n)] end if end proc:
